#ifndef __Auth4cCData_Auth4cFactory_h__
#define __Auth4cCData_Auth4cFactory_h__

#if defined (_WINDOWS)
#	include <windows.h>
#	if defined (AUTH4CCDATA_EXPORTS)
#		define Auth4cCData_Exports __declspec( dllexport )
#	else
#		define Auth4cCData_Exports __declspec( dllimport )
#	endif /* AUTH4CCDATA_EXPORTS */
#	pragma warning( disable : 4355 )
#else
#	define Auth4cCData_Exports
#endif /* _WINDOWS */


#	if defined __cplusplus
extern "C" {
#	endif

	typedef void* USER;

	Auth4cCData_Exports int auth4c_init( const char* pszInit );

	Auth4cCData_Exports USER auth4c_authenticate( const char* pszUserId, const char* pszPassword, const char* pszProfile );
	Auth4cCData_Exports USER auth4c_authenticateD( const char* pszDomain, const char* pszUserId, const char* pszPassword, const char* pszProfile );

	Auth4cCData_Exports int auth4c_persistSession( USER user );
	Auth4cCData_Exports USER auth4c_retrieveSession( const char* pszSession );
	Auth4cCData_Exports int auth4c_killSession( const char* pszSession );

	Auth4cCData_Exports int auth4c_session( char* pszSession, int nMaxLen, USER user );
	Auth4cCData_Exports int auth4c_customer( char* pszCustomer, int nMaxLen, USER user );
	Auth4cCData_Exports int auth4c_domain( char* pszDomain, int nMaxLen, USER user );
	Auth4cCData_Exports int auth4c_userId( char* pszId, int nMaxLen, USER user );
	Auth4cCData_Exports int auth4c_userName( char* pszName, int nMaxLen, USER user );
	Auth4cCData_Exports int auth4c_userContact( char* pszContact, int nMaxLen, USER user );

	Auth4cCData_Exports int auth4c_isMemberOf( int nTeam, USER user );
	Auth4cCData_Exports int auth4c_hasRole( int nProduct, int nRole, USER user );
	Auth4cCData_Exports int auth4c_hasPermission( int nProduct, int nPermission, USER user );

	Auth4cCData_Exports void auth4c_close( USER user );

#	if defined __cplusplus
}
#	endif
#endif /* !__Auth4cCData_Auth4cFactory_h__ */
