/*

  $Id: Auth4cDB.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4cDal_Auth4cDB_h__
#define __Auth4cDal_Auth4cDB_h__

#include <Auth4cDal/Auth4cDal.h>
#include <librfcdal/SqlSchema.h>
#include <librfcdal/DalDatabase.h>

#include <Base4c/Mutex.h>

namespace Auth4cDal
{
	class Auth4cDal_Export Auth4cDB
	{
		private:
			RfcDal::DalDatabase* _pdb;
			int _nUsageCount;
			Base4c::Mutex _mx;

		public:
			Auth4cDB( RfcDal::DalDatabase* pdb = NULL );
			Auth4cDB( const Auth4cDB& db );
			virtual ~Auth4cDB();

			Auth4cDB& operator=( const Auth4cDB& db );

			bool inUse() const;

		protected:
			void ucInc();
			void ucDec();

			friend class Connection;
	};

	typedef std::vector<Auth4cDB> Auth4cDBList;

	class Auth4cDal_Export Connection
	{
		private:
			Auth4cDB* _pdb;

		public:
			Connection( Auth4cDB* pdb );
			Connection( const Connection& connection );
			virtual ~Connection();

			Connection& operator=( Connection& connection );

			RfcDal::DalDatabase& db();
			operator RfcDal::DalDatabase&();
	};

	const Auth4cDal_Export RfcDal::SqlSchema& schema();
	Auth4cDal_Export Connection connection();
	void Auth4cDal_Export connect( const std::string& strConnect );
	void Auth4cDal_Export disconnect();
};

#endif /* !__Auth4cDal_Auth4cDB_h__ */
