#ifndef __AuthenticationLibraryXQuery_h__
#define __AuthenticationLibraryXQuery_h__

#include <Auth4cDal/AuthenticationLibraryQuery.h>

#include <Auth4cDal/Auth4cDal.h>

namespace Auth4cDal
{
	class Auth4cDal_Export AuthenticationLibraryXQuery : public AuthenticationLibraryQuery
	{
		private:
			RfcDal::SqlTable _tbSharedObject;
			RfcDal::SqlColumn _colPlatform;
			RfcDal::SqlColumn _colAuthenticationLibrary1;
			RfcDal::SqlColumn _colSharedObject;
			RfcDal::SqlColumnPtr _valPlatformConstraint;

		public:
			AuthenticationLibraryXQuery( const RfcDal::SqlSchema& schema );
			AuthenticationLibraryXQuery( const RfcDal::SqlTable& table );
			virtual ~AuthenticationLibraryXQuery();

			const RfcDal::SqlColumn& columnPlaform() const;
			const RfcDal::SqlColumn& columnSharedObject() const;

			RfcDal::SqlColumn& columnPlaform();
			RfcDal::SqlColumn& columnSharedObject();

			void constrainPlatform( const RfcDal::SqlColumnPtr& value );

			virtual void addConstraints( RfcDal::SqlCompoundCondition& conditionS, bool bAddBaseConstraints = true ) ;

			virtual int select( RfcDal::DalDatabase::Result& result, RfcDal::DalDatabase& database, RfcDal::SqlQueryBase::QueryType type = RfcDal::SqlQueryBase::full ) ;
			virtual int insert( RfcDal::DalDatabase& database ) ;
			virtual int update( RfcDal::DalDatabase& database ) ;
			virtual int remove( RfcDal::DalDatabase& database ) ;
	};
};	// end Auth4cDal

#endif /* !__AuthenticationLibraryXQuery_h__ */
