/*

  $Id: AuthenticatedUser.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c__AuthenticatedUser_h__
#define __Auth4c__AuthenticatedUser_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Exception.h>
#include <Auth4cData/User.h>
#include <Auth4cData/Session.h>
#include <Auth4cData/Profile.h>
#include <Auth4cData/AuthenticationToken.h>

#include <map>

namespace Auth4cData
{
	class SessionMap;

	class Auth4cData_Export AuthenticatedUser : public User
	{
		private:
			Session* _psession;
			Profile _profile;

		public:
			AuthenticatedUser();
			AuthenticatedUser( const User& user, const Session& session, const Profile& profile );
			AuthenticatedUser( const AuthenticatedUser& user );
			virtual ~AuthenticatedUser();

			const AuthenticatedUser& operator=( const AuthenticatedUser& user );

			const Session& session() const;
			const Profile& profile() const;

			Session& session();

			void passwd( Auth4cData::AuthenticationToken& authTokenCurrent, Auth4cData::AuthenticationToken& authTokenNew );
	};

	class Auth4cData_Export AuthenticatedUserMap : public std::map<User::Key, AuthenticatedUser>
	{
	};

};

#endif /* !__Auth4c__AuthenticatedUser_h__ */
