/*

  $Id: Customer.h 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_Customer_h__
#define __Auth4c_Customer_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Domain.h>
#include <Auth4cData/Team.h>
#include <Auth4cData/Base.h>

#include <string>

namespace Auth4cData
{
	class Auth4cData_Export Customer : public Base
	{
		public:
			static const Customer allCustomers;

		private:
			std::string _strCustomer;
			std::string _strName;
			DomainPtrMap _domainS;
			TeamPtrMap _teamS;

		public:
			Customer();
			Customer( const std::string& strCustomer,
						const std::string& strName = std::string() );
			Customer( const Customer& customer );
			virtual ~Customer();

			const Customer& operator=( const Customer& customer );

			const std::string& customer() const;
			const std::string& name() const;
			const DomainPtrMap& domains() const;
			const TeamPtrMap& teams() const;

			void setName( const std::string& strName );
			DomainPtrMap& domains();
			TeamPtrMap& teams();
	};

	class Auth4cData_Export CustomerMap : public std::map<std::string, Customer>
	{
	};
};

#endif /* !__Auth4c_Customer_h__ */
