/*

  $Id: Domain.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_Domain_h__
#define __Auth4c_Domain_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Base.h>
#include <Auth4cData/User.h>
#include <Auth4cData/Exception.h>

#include <map>
#include <string>

namespace Auth4cData
{
	class Authenticator;
	class Customer;

	class Auth4cData_Export Domain : public Base
	{
		private:
			const Customer* _pcustomer;
			std::string _strDomain;
			std::string _strDescription;
			Authenticator* _pauthenticator;
			UserMap _userS;

		public:
			Domain();
			Domain( const Customer& customer, const std::string strDomain );
			Domain( const Domain& domain );
			virtual ~Domain();

			const Domain& operator=( const Domain& domain );

			bool operator==( const Domain& domain ) const;

			const Customer& customer() const;
			const std::string& domain() const;
			const std::string& description() const;
			Authenticator& authenticator() const;
			const UserMap& users() const;

			void setDescription( const std::string& strDescription );
			void setAuthenticator( Authenticator& authenticator );
			UserMap& users( bool bRefresh = false ) ;

			void createUser( const Auth4cData::User& user ) ;
			void deleteUser( const Auth4cData::User& user ) ;
	};

	class Auth4cData_Export DomainMap : public std::map<std::string, Domain>
	{
	};

	class Auth4cData_Export DomainPtrMap : public std::map<std::string, Domain*>
	{
	};
};

#endif /* !__Auth4c_Domain_h__ */
