/*

  $Id: PRStatus.h 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4cData_PRStatus_h__
#define __Auth4cData_PRStatus_h__

#include <Auth4cData/Auth4cData.h>

namespace Auth4cData
{
	class Auth4cData_Export PRStatus
	{
		public:
			typedef enum{ statusRevoked = -1, statusDenied = 0, statusGranted = 1 } PRStatusRaw;

		private:
			PRStatusRaw _status;

		public:
			PRStatus( PRStatusRaw status = statusDenied );
			PRStatus( const PRStatus& status );
			virtual ~PRStatus();

			const PRStatus& operator=( const PRStatus& status );

			PRStatus operator+( const PRStatus& status ) const;
			const PRStatus& operator+=( const PRStatus& status );

			bool operator==( const PRStatus& status ) const;

			operator PRStatusRaw() const;

			static PRStatus fromInt( int nStatus );
	};
};

#endif /* !__Auth4cData_PRStatus_h__ */
