/*

  $Id: Platform.h 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_Platform_h__
#define __Auth4c_Platform_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Base.h>

#include <string>
#include <map>

namespace Auth4cData
{
	class Auth4cData_Export Platform : public Base
	{
		private:
			std::string _strPlatform;
			std::string _strDescription;

		public:
			Platform( const std::string strPlatform = std::string(), const std::string& strDescription = std::string() );
			Platform( const Platform& platform );
			virtual ~Platform();

			const Platform& operator=( const Platform& platform );

			const std::string& platform() const;
			const std::string& description() const;
	};

	class Auth4cData_Export PlatformMap : public std::map<std::string, Platform>
	{
	};
};

#endif /* !__Auth4c_Platform_h__ */
