/*

  $Id: Profile.h 607 2017-05-26 13:06:51Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_Profile_h__
#define __Auth4c_Profile_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Base.h>
#include <Auth4cData/Product.h>

#include <map>
#include <string>

namespace Auth4cData
{
	class Auth4cData_Export Profile : public Base
	{
		private:
			std::string _strProfile;
			bool _bDefault;
			ProductInitMap _productS;

		public:
			Profile( const std::string& strProfile = std::string(), bool bDefault = false );
			Profile( const Profile& profile );
			virtual ~Profile();

			const Profile& operator=( const Profile& profile );

			const std::string& profile() const;
			bool isDefault() const;
			const ProductInitMap& products() const;

			void setProducts( const ProductInitMap& productS );
	};

	class Auth4cData_Export ProfileMap : public std::map<std::string, Profile>
	{
		private:

		public:
			ProfileMap();
			ProfileMap( const ProfileMap& profileS );
			virtual ~ProfileMap();

			const ProfileMap& operator=( const ProfileMap& profileS );
	};
};

#endif /* !__Auth4c_Profile_h__ */
