/*

  $Id: Session.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c__Session_h__
#define __Auth4c__Session_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Base.h>
#include <Auth4cData/Exception.h>

#include <string>

namespace Auth4cData
{
	class Auth4cData_Export Session : public Base
	{
		private:
			std::string _strSessionId;
			static int _nTimeout;
			time_t _tAccessed;

		public:
			Session();
			Session( const std::string& strSessionId );
			Session( const Session& session );
			virtual ~Session();

			const Session& operator=( const Session& session );

			virtual const std::string& str() const;
			virtual Session* copy() const;

			static void setSessionTimeout( int nSeconds );
			void access() ;
	};
};

#endif /* !__Auth4c__Session_h__ */
