/*

  $Id: SessionMap.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4cData_SessionMap_h__
#define __Auth4cData_SessionMap_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/AuthenticatedUser.h>
#include <Auth4cData/Exception.h>

#include <string>

namespace Auth4cData
{
	class Auth4cData_Export SessionMap : public std::map<std::string, AuthenticatedUser>
	{
		public:
			void addSession( const AuthenticatedUser& user ) ;
			const AuthenticatedUser& session( const Session& session ) ;
			void kill( const Session& session ) ;
			void cleanUp();
	};
};

#endif /* !__Auth4cData_SessionMap_h__ */
