/*

  $Id: SharedObject.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_SharedObject_h__
#define __Auth4c_SharedObject_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Base.h>
#include <Auth4cData/Platform.h>
#include <Auth4cData/Exception.h>

namespace Auth4cData
{
	class AuthenticationLibrary;

	class Auth4cData_Export SharedObject : public Base
	{
		public: 
			typedef std::pair<std::string, int> Key;

		private:
			const Platform* _pplatform;
			const AuthenticationLibrary* _pauthenticationLibrary;
			std::string _strSharedObject;
			Key _key;

		public:
			SharedObject();
			SharedObject( const Platform& platform, const AuthenticationLibrary& authenticationLibrary, const std::string& strSharedObject );
			SharedObject( const SharedObject& object );
			virtual ~SharedObject();

			const SharedObject& operator=( const SharedObject& object );

			const Key& key() const;
			const Platform& platform() const;
			const AuthenticationLibrary& authenticationLibrary() const;
			const std::string& sharedObject() const;
	};

	class Auth4cData_Export SharedObjectMap : public std::map<SharedObject::Key, SharedObject>
	{
	};

	class Auth4cData_Export SharedObjectPtrMap : public std::map<std::string, SharedObject*>
	{
	};
};

#endif /* !__Auth4c_SharedObject_h__ */
