/*

  $Id: Team.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_Team_h__
#define __Auth4c_Team_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/Base.h>
#include <Auth4cData/Product.h>
#include <Auth4cData/TeamMember.h>
#include <Auth4cData/Exception.h>

#include <string>
#include <map>

namespace Auth4cData
{
	class Customer;

	class Auth4cData_Export Team : public Base
	{
		private:
			int _nTeam;
			const Customer* _pcustomer;
			std::string _strName;
			TeamMemberMap _memberS;
			ProductMap _productS;

		public:
			Team();
			Team( const Customer& customer, int nTeam, const std::string& strName = std::string() );
			Team( const Team& team );
			virtual ~Team();

			const Team& operator=( const Team& team );

			int team() const;
			const Customer& customer() const;
			const std::string& name() const;
			const TeamMemberMap& members() const;
			const ProductMap& products() const;

			void setCustomer( const Customer& customer );
			void setName( const std::string& strName );
			TeamMemberMap& members();
			ProductMap& products();

		protected:
			void loadMembers();

			friend class Factory;
	};

	class Auth4cData_Export TeamMap : public std::map<int, Team>
	{
	};

	class Auth4cData_Export TeamPtrMap : public std::map<int, Team*>
	{
	};
};

#endif /* !__Auth4c_Team_h__ */
