/*

  $Id: TeamMember.h 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_TeamMember_h__
#define __Auth4c_TeamMember_h__

#include <Auth4cData/Auth4cData.h>
#include <Auth4cData/User.h>

#include <vector>

namespace Auth4cData
{
	class Auth4cData_Export TeamMember : public User
	{
		private:
			bool _bIsLead;

		public:
			TeamMember();
			TeamMember( User user, bool bIsLead );
			TeamMember( const TeamMember& member );
			virtual ~TeamMember();

			const TeamMember& operator=( const TeamMember& member );

			bool isLead() const;

			void setLead( bool bIsLead );
	};

	class Auth4cData_Export TeamMemberMap : public std::map<User::Key, TeamMember>
	{
	};
};

#endif /* !__Auth4c_TeamMember_h__ */
