/*

  $Id: XTeam.h 387 2015-12-08 18:53:52Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4c_XTeam_h__
#define __Auth4c_XTeam_h__

#include <Auth4cData/Auth4cData.h>

#include <Auth4cData/Team.h>

namespace Auth4cData
{
	typedef std::pair<std::string, std::string> AlienKey;
	typedef std::pair<AlienKey, int> AlienMapKey;

	class Auth4cData_Export XTeam
	{
		private:
			std::string _strDomain;
			std::string _strAlienGroup;
			std::string _strAlienGroupLeadGroup;
			int _nTeam;
			AlienKey _keyAlien;
			AlienMapKey _keyAlienMap;

		public:
			XTeam();
			XTeam( const std::string& strDomain,
					const std::string& strAlienGroup,
					const std::string& strAlienGroupLeadGroup,
					int nTeam );
			XTeam( const XTeam& team );
			virtual ~XTeam();

			const XTeam& operator=( const XTeam& team );

			const std::string& domain() const;
			const std::string& alienGroup() const;
			const std::string& alienGroupLeadGroup() const;
			int team() const;
			const AlienKey& keyAlien() const;
			const AlienMapKey& keyAlienMap() const;
	};

	class Auth4cData_Export XTeamMap : public std::map<AlienMapKey, XTeam>
	{
	};

	class Auth4cData_Export XTeamPtrMap : public std::map<AlienMapKey, XTeam*>
	{
	};

	class Auth4cData_Export XTeamPtrAlienMap : public std::map<AlienKey, XTeamPtrMap>
	{
	};

	class Auth4cData_Export XTeamPtrAlienRevMap : public std::map<int, XTeamPtrMap>
	{
	};
};

#endif /* !__Auth4c_XTeam_h__ */
