/*

  $Id: Auth4cService.h 689 2018-11-28 17:54:35Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4cDataXML_Auth4cService_h__
#define __Auth4cDataXML_Auth4cService_h__

#include <Auth4cData/Exception.h>
#include <Auth4cDataXML/Auth4cDataXML.h>

#include <Base4c/DaemonComm.h>
#include <Base4c/Exception.h>
//#include <Base4c/User.h>
#include <Base4c/Semaphore.h>

#include <librfcdal/DalDatabaseException.h>

#include <librfc/XMLDoc.hpp>

namespace Auth4cDataXML
{
	class Auth4cDataXML_Export Auth4cService
	{
		private:
			static bool _bIsConnected;
			static void(*_usmCallback)( Base4c::DaemonComm::Status status, const std::string& strMessage );
			static Base4c::DaemonComm* _pcomm;
			static Base4c::Semaphore _semaphore;
			static Rfc::XMLDoc _docResponse;
			static bool _bInTransaction;
			static std::string _strHost;

		public:
			static bool connect( const std::string& strService );
			static void disconnect();

			static const std::string& host();

			static bool isConnected();
			static Base4c::DaemonComm& comm();

			static void transact( Rfc::XMLDoc& docResponse, const Rfc::XMLDoc& docRequest );

			static void setCallback( void(*usmCallback)( Base4c::DaemonComm::Status, const std::string& ) );
			static void usmCallback( Base4c::DaemonComm::Status status, const std::string& strMessage );
	};
};

#endif /* !__Auth4cDataXML_Auth4cService_h__ */
