/*

  $Id: LoginDialog.h 404 2015-12-15 13:47:27Z john $

  Copyright (c) 2008, The 4c Company. All rights reserved.
*/

#ifndef __Auth4cUIComponents_LoginDialog_h__
#define __Auth4cUIComponents_LoginDialog_h__

#include <Auth4cUIComponents/auth4cuicomponents_global.h>

#include <Auth4cData/AuthenticatedUser.h>
#include <Auth4cClientConfig/Settings.h>

#include <QDialog>
#include <Auth4cUIComponents/GeneratedFiles/ui_LoginDialog.h>

namespace Auth4cUIComponents
{
	class AUTH4CUICOMPONENTS_EXPORT LoginDialog : public QDialog, private Ui::LoginDialog
	{
		Q_OBJECT

		private:
			Auth4cClientConfig::Settings& _settings;
			Auth4cData::AuthenticatedUser _user;

		public:
			LoginDialog( QWidget* pparent, Auth4cClientConfig::Settings& settings );
			virtual ~LoginDialog();

			const Auth4cData::AuthenticatedUser& user() const;

		protected slots:
			void accept();
			void reject();
			void onHelp();
	};
};

#endif /* !__Auth4cUIComponents_LoginDialog_h__ */
